Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# DebugKeyTable Class Reference

Contains a table of debug keys and all methods for using debug keys. More...

`#include <DebugKeyTable.h>`

Collaboration diagram for DebugKeyTable:

[legend]
List of all members.

## Public Types
enum | debugKeyID { sendImage, sendJPEGImage, sendLowResImage, sendSensorData, sendJointData, sendOdometryData, sendMotionInfo, sendBodyPosture, sendPercepts, sendSpecialPercept, sendWorldState, sendGameControlData, sendPlayerConfig, sendSoundRequest, sendOptionRatings, sendKickRecords, sendTimeOffsets, printRobotStatus, printCBBRules, printPixelUsage, learnWalking, sendDDPInfo, sendWalkingEngineInfo, sendKickEngineInfo, sendMSHBallLocatorEvolution, numOfDebugKeysForDebugKeyToolbar, sendXabsl2DebugMessagesForBehaviorControl, sendXabsl2DebugMessagesForHeadControl, sendColorTable64, sendColorTableReferenceColor, sendColorTableCuboids, sendHistogram_imageIntensityY, sendHistogram_imageIntensityU, sendHistogram_imageIntensityV, sendHistogram_scanLineIntensityY, sendHistogram_scanLineIntensityU, sendHistogram_scanLineIntensityV, sendHistogram_colorFrequency, sendHistogram_lengthOfSegments, send_selfLocator_drawing, send_imageProcessor_general_drawing, send_imageProcessor_horizon_drawing, send_imageProcessor_scanLines_drawing, send_imageProcessor_coloredSegments1_drawing, send_imageProcessor_coloredSegments2_drawing, send_imageProcessor_coloredSegments3_drawing, send_imageProcessor_calibration1_drawing, send_imageProcessor_calibration2_drawing, send_imageProcessor_ball1_drawing, send_imageProcessor_ball2_drawing, send_imageProcessor_ball3_drawing, send_imageProcessor_ball4_drawing, send_imageProcessor_ground_drawing, send_imageProcessor_flagsAndGoals_drawing, send_imageProcessor_obstacles_drawing, send_imageProcessor_gradients_drawing, send_imageProcessor_edges_drawing, send_imageProcessor_lines_drawing, send_imageProcessor_linefragments_drawing, send_imageProcessor_robot_detection_drawing, send_sketch_drawing, send_imageProcessor_multipleBallPercepts_drawing, send_circlePoints_image_drawing, send_selfLocatorField_drawing, send_teamBallLocatorFieldParticles_drawing, send_teamBallLocatorField_drawing, send_comboBallLocatorField_drawing, send_comboTeamBallLocatorField_drawing, send_ballLocatorField_drawing, send_goaliePositionField_drawing, send_headControlField_drawing, send_playerModelField_drawing, send_behavior_CBBVector_drawing, send_behavior_CBBWay_drawing, send_behavior_kickAngles_drawing, send_behavior_aStarSearch_drawing, send_dribbleBall_drawing, send_percepts_robot_drawing, send_lineCrossingsField_drawing, send_multipleBallPerceptsField_drawing, send_circlePoints_Field_drawing, send_behavior_kickAnglesRadar_drawing, send_models_corridorsRadar_drawing, send_segmentedImage1_image, send_segmentedImage2_image, send_segmentedImage3_image, send_classificationY_image, send_classificationU_image, send_classificationV_image, send_colorFrequency_image, send_imageProcessorGeneral_image, send_imageProcessorScanLines_image, send_imageProcessorBall_image, send_imageProcessorGoal1_image, send_imageProcessorGoal2_image, send_imageProcessorFlags_image, send_imageProcessorPlayers_image, send_imageProcessorGradients_image, send_imageMotionRecognition_image, send_imageProcessorRobotDetection_image, sendImageProcessorTime, sendSensorDataProcessorTime, sendBallLocatorTime, sendTeamBallLocatorTime, sendSelfLocatorTime, sendPlayersLocatorTime, sendObstaclesLocatorTime, sendBehaviorControlTime, sendMotionControlTime, sendSoundControlTime, sendSpecialVisionTime, sendPerceptBehaviorControlTime, sendSensorBehaviorControlTime, sendHeadControlTime, sendCollisionDetectorTime, sendRobotStateDetectorTime, sendGTCamWorldState, sendATH2005SLInfo, numOfDebugKeys, send_imageProcessorGoals_image = send_imageProcessorGoal1_image }
| IDs for Debug Keys. More...
## Public Member Functions
| DebugKeyTable ()
| Constructor, resets the table.
void | set (debugKeyID id, DebugKey::modes mode=DebugKey::always, int n=0)
| sets a debug key
void | setMode (debugKeyID id, DebugKey::modes mode)
| sets only the mode of a debug key
void | setN (debugKeyID id, unsigned int n)
| sets only the parameter n of a debug key
DebugKey::modes | getMode (debugKeyID id) const
| returns the mode of a debug key
unsigned int | getN (debugKeyID id) const
| returns the parameter n of a debug key
bool | isActive (debugKeyID id) const
| returns whether an debug Key is active in the current frame
void | reset ()
| resets all debug keys to disabled
void | activate ()
| Determines for all keys if they are active in the current frame.
bool | operator== (const DebugKeyTable &other)
| the == operator
bool | operator!= (const DebugKeyTable &other)
| the != operator
## Static Public Member Functions
char * | getDebugKeyName (debugKeyID aID)
| returns the DebugKey's name
## Protected Attributes
DebugKey | debugKeys [numOfDebugKeys]
| The Debug Key Table.

## Detailed Description

Contains a table of debug keys and all methods for using debug keys.

Author:
  Ronnie Brunn

  Max Risler

  Martin Lötzsch

Definition at line 63 of file DebugKeyTable.h.

## Member Enumeration Documentation

enum DebugKeyTable::debugKeyID

  | IDs for Debug Keys. enter new Debug Keys here and add the corresponding string in getDebugKeyName Enumeration values:
  sendImage |
  sendJPEGImage |
  sendLowResImage |
  sendSensorData |
  sendJointData |
  sendOdometryData |
  sendMotionInfo |
  sendBodyPosture |
  sendPercepts |
  sendSpecialPercept |
  sendWorldState |
  sendGameControlData |
  sendPlayerConfig |
  sendSoundRequest |
  sendOptionRatings |
  sendKickRecords |
  sendTimeOffsets |
  printRobotStatus |
  printCBBRules |
  printPixelUsage |
  learnWalking |
  sendDDPInfo |
  sendWalkingEngineInfo |
  sendKickEngineInfo |
  sendMSHBallLocatorEvolution |
  numOfDebugKeysForDebugKeyToolbar |
  sendXabsl2DebugMessagesForBehaviorControl |
  sendXabsl2DebugMessagesForHeadControl |
  sendColorTable64 |
  sendColorTableReferenceColor |
  sendColorTableCuboids |
  sendHistogram_imageIntensityY |
  sendHistogram_imageIntensityU |
  sendHistogram_imageIntensityV |
  sendHistogram_scanLineIntensityY |
  sendHistogram_scanLineIntensityU |
  sendHistogram_scanLineIntensityV |
  sendHistogram_colorFrequency |
  sendHistogram_lengthOfSegments |
  send_selfLocator_drawing |
  send_imageProcessor_general_drawing |
  send_imageProcessor_horizon_drawing |
  send_imageProcessor_scanLines_drawing |
  send_imageProcessor_coloredSegments1_drawing |
  send_imageProcessor_coloredSegments2_drawing |
  send_imageProcessor_coloredSegments3_drawing |
  send_imageProcessor_calibration1_drawing |
  send_imageProcessor_calibration2_drawing |
  send_imageProcessor_ball1_drawing |
  send_imageProcessor_ball2_drawing |
  send_imageProcessor_ball3_drawing |
  send_imageProcessor_ball4_drawing |
  send_imageProcessor_ground_drawing |
  send_imageProcessor_flagsAndGoals_drawing |
  send_imageProcessor_obstacles_drawing |
  send_imageProcessor_gradients_drawing |
  send_imageProcessor_edges_drawing |
  send_imageProcessor_lines_drawing |
  send_imageProcessor_linefragments_drawing |
  send_imageProcessor_robot_detection_drawing |
  send_sketch_drawing |
  send_imageProcessor_multipleBallPercepts_drawing |
  send_circlePoints_image_drawing |
  send_selfLocatorField_drawing |
  send_teamBallLocatorFieldParticles_drawing |
  send_teamBallLocatorField_drawing |
  send_comboBallLocatorField_drawing |
  send_comboTeamBallLocatorField_drawing |
  send_ballLocatorField_drawing |
  send_goaliePositionField_drawing |
  send_headControlField_drawing |
  send_playerModelField_drawing |
  send_behavior_CBBVector_drawing |
  send_behavior_CBBWay_drawing |
  send_behavior_kickAngles_drawing |
  send_behavior_aStarSearch_drawing |
  send_dribbleBall_drawing |
  send_percepts_robot_drawing |
  send_lineCrossingsField_drawing |
  send_multipleBallPerceptsField_drawing |
  send_circlePoints_Field_drawing |
  send_behavior_kickAnglesRadar_drawing |
  send_models_corridorsRadar_drawing |
  send_segmentedImage1_image |
  send_segmentedImage2_image |
  send_segmentedImage3_image |
  send_classificationY_image |
  send_classificationU_image |
  send_classificationV_image |
  send_colorFrequency_image |
  send_imageProcessorGeneral_image |
  send_imageProcessorScanLines_image |
  send_imageProcessorBall_image |
  send_imageProcessorGoal1_image |
  send_imageProcessorGoal2_image |
  send_imageProcessorFlags_image |
  send_imageProcessorPlayers_image |
  send_imageProcessorGradients_image |
  send_imageMotionRecognition_image |
  send_imageProcessorRobotDetection_image |
  sendImageProcessorTime |
  sendSensorDataProcessorTime |
  sendBallLocatorTime |
  sendTeamBallLocatorTime |
  sendSelfLocatorTime |
  sendPlayersLocatorTime |
  sendObstaclesLocatorTime |
  sendBehaviorControlTime |
  sendMotionControlTime |
  sendSoundControlTime |
  sendSpecialVisionTime |
  sendPerceptBehaviorControlTime |
  sendSensorBehaviorControlTime |
  sendHeadControlTime |
  sendCollisionDetectorTime |
  sendRobotStateDetectorTime |
  sendGTCamWorldState |
  sendATH2005SLInfo |
  numOfDebugKeys |
  send_imageProcessorGoals_image |
Definition at line 70 of file DebugKeyTable.h. Referenced by reset().

## Constructor & Destructor Documentation

DebugKeyTable::DebugKeyTable | ( |  | ) |

| Constructor, resets the table. Definition at line 26 of file DebugKeyTable.cpp. References reset().

Here is the call graph for this function:

## Member Function Documentation

char* DebugKeyTable::getDebugKeyName | ( | debugKeyID | aID | ) | `[inline, static]`

| returns the DebugKey's name Definition at line 217 of file DebugKeyTable.h. References learnWalking, printCBBRules, printPixelUsage, printRobotStatus, send_ballLocatorField_drawing, send_behavior_aStarSearch_drawing, send_behavior_CBBVector_drawing, send_behavior_CBBWay_drawing, send_behavior_kickAngles_drawing, send_behavior_kickAnglesRadar_drawing, send_circlePoints_Field_drawing, send_circlePoints_image_drawing, send_classificationU_image, send_classificationV_image, send_classificationY_image, send_colorFrequency_image, send_comboBallLocatorField_drawing, send_comboTeamBallLocatorField_drawing, send_dribbleBall_drawing, send_goaliePositionField_drawing, send_headControlField_drawing, send_imageMotionRecognition_image, send_imageProcessor_ball1_drawing, send_imageProcessor_ball2_drawing, send_imageProcessor_ball3_drawing, send_imageProcessor_ball4_drawing, send_imageProcessor_calibration1_drawing, send_imageProcessor_calibration2_drawing, send_imageProcessor_coloredSegments1_drawing, send_imageProcessor_coloredSegments2_drawing, send_imageProcessor_coloredSegments3_drawing, send_imageProcessor_edges_drawing, send_imageProcessor_flagsAndGoals_drawing, send_imageProcessor_general_drawing, send_imageProcessor_gradients_drawing, send_imageProcessor_ground_drawing, send_imageProcessor_horizon_drawing, send_imageProcessor_linefragments_drawing, send_imageProcessor_lines_drawing, send_imageProcessor_multipleBallPercepts_drawing, send_imageProcessor_obstacles_drawing, send_imageProcessor_robot_detection_drawing, send_imageProcessor_scanLines_drawing, send_imageProcessorBall_image, send_imageProcessorFlags_image, send_imageProcessorGeneral_image, send_imageProcessorGoal1_image, send_imageProcessorGoal2_image, send_imageProcessorGradients_image, send_imageProcessorPlayers_image, send_imageProcessorRobotDetection_image, send_imageProcessorScanLines_image, send_lineCrossingsField_drawing, send_models_corridorsRadar_drawing, send_multipleBallPerceptsField_drawing, send_percepts_robot_drawing, send_playerModelField_drawing, send_segmentedImage1_image, send_segmentedImage2_image, send_segmentedImage3_image, send_selfLocator_drawing, send_selfLocatorField_drawing, send_sketch_drawing, send_teamBallLocatorField_drawing, send_teamBallLocatorFieldParticles_drawing, sendATH2005SLInfo, sendBallLocatorTime, sendBehaviorControlTime, sendBodyPosture, sendCollisionDetectorTime, sendColorTable64, sendColorTableCuboids, sendColorTableReferenceColor, sendDDPInfo, sendGameControlData, sendHeadControlTime, sendHistogram_colorFrequency, sendHistogram_imageIntensityU, sendHistogram_imageIntensityV, sendHistogram_imageIntensityY, sendHistogram_lengthOfSegments, sendHistogram_scanLineIntensityU, sendHistogram_scanLineIntensityV, sendHistogram_scanLineIntensityY, sendImage, sendImageProcessorTime, sendJointData, sendJPEGImage, sendKickEngineInfo, sendKickRecords, sendLowResImage, sendMotionControlTime, sendMotionInfo, sendMSHBallLocatorEvolution, sendObstaclesLocatorTime, sendOdometryData, sendOptionRatings, sendPerceptBehaviorControlTime, sendPercepts, sendPlayerConfig, sendPlayersLocatorTime, sendRobotStateDetectorTime, sendSelfLocatorTime, sendSensorBehaviorControlTime, sendSensorData, sendSensorDataProcessorTime, sendSoundControlTime, sendSoundRequest, sendSpecialPercept, sendSpecialVisionTime, sendTeamBallLocatorTime, sendTimeOffsets, sendWalkingEngineInfo, sendWorldState, sendXabsl2DebugMessagesForBehaviorControl, and sendXabsl2DebugMessagesForHeadControl.

void DebugKeyTable::set | ( | debugKeyID | id,
|  | DebugKey::modes | mode = DebugKey::always,
|  | int | n = 0
| ) |

| sets a debug key Definition at line 31 of file DebugKeyTable.cpp. References debugKeys, and DebugKey::set(). Referenced by operator>>(), and reset().

Here is the call graph for this function:

void DebugKeyTable::setMode | ( | debugKeyID | id,
|  | DebugKey::modes | mode
| ) |

| sets only the mode of a debug key Definition at line 36 of file DebugKeyTable.cpp. References debugKeys, and DebugKey::set().

Here is the call graph for this function:

void DebugKeyTable::setN | ( | debugKeyID | id,
|  | unsigned int | n
| ) |

| sets only the parameter n of a debug key Definition at line 41 of file DebugKeyTable.cpp. References debugKeys, and DebugKey::set().

Here is the call graph for this function:

DebugKey::modes DebugKeyTable::getMode | ( | debugKeyID | id | ) | const

| returns the mode of a debug key Definition at line 46 of file DebugKeyTable.cpp. References debugKeys, and DebugKey::mode. Referenced by operator<<().

unsigned int DebugKeyTable::getN | ( | debugKeyID | id | ) | const

| returns the parameter n of a debug key Definition at line 51 of file DebugKeyTable.cpp. References debugKeys, and DebugKey::n. Referenced by operator<<().

bool DebugKeyTable::isActive | ( | debugKeyID | id | ) | const

| returns whether an debug Key is active in the current frame Definition at line 56 of file DebugKeyTable.cpp. References DebugKey::active, and debugKeys. Referenced by GTXabsl2EngineExecutor::executeEngine().

void DebugKeyTable::reset | ( |  | ) |

| resets all debug keys to disabled Definition at line 62 of file DebugKeyTable.cpp. References debugKeyID, numOfDebugKeys, and set(). Referenced by DebugKeyTable().

Here is the call graph for this function:

void DebugKeyTable::activate | ( |  | ) |

| Determines for all keys if they are active in the current frame. Definition at line 70 of file DebugKeyTable.cpp. References DebugKey::active, debugKeys, SystemCall::getCurrentSystemTime(), DebugKey::last, DebugKey::mode, DebugKey::n, and numOfDebugKeys. Referenced by Process::processMain().

Here is the call graph for this function:

bool DebugKeyTable::operator== | ( | const DebugKeyTable & | other | ) |

| the == operator Definition at line 118 of file DebugKeyTable.cpp. References debugKeys, DebugKey::mode, DebugKey::n, and numOfDebugKeys.

bool DebugKeyTable::operator!= | ( | const DebugKeyTable & | other | ) | `[inline]`

| the != operator Definition at line 395 of file DebugKeyTable.h.

## Member Data Documentation

DebugKey DebugKeyTable::debugKeys[numOfDebugKeys]`[protected]`

| The Debug Key Table. Definition at line 361 of file DebugKeyTable.h. Referenced by activate(), getMode(), getN(), isActive(), operator==(), set(), setMode(), and setN().

The documentation for this class was generated from the following files:

- Tools/Debugging/DebugKeyTable.h
- Tools/Debugging/DebugKeyTable.cpp